/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.ruoyi.common.core.utils.StringUtils
 *  com.ruoyi.common.core.web.controller.BaseController
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.common.log.annotation.Log
 *  com.ruoyi.common.log.enums.BusinessType
 *  com.ruoyi.common.security.annotation.RequiresPermissions
 *  com.ruoyi.common.security.utils.SecurityUtils
 *  com.ruoyi.system.controller.SysMenuController
 *  com.ruoyi.system.domain.SysMenu
 *  com.ruoyi.system.service.ISysMenuService
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.validation.annotation.Validated
 *  org.springframework.web.bind.annotation.DeleteMapping
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.ruoyi.system.controller;

import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.ruoyi.system.domain.SysMenu;
import com.ruoyi.system.service.ISysMenuService;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value={"/menu"})
public class SysMenuController
extends BaseController {
    @Autowired
    private ISysMenuService menuService;

    @RequiresPermissions(value={"system:menu:list"})
    @GetMapping(value={"/list"})
    public AjaxResult list(SysMenu menu) {
        Long userId = SecurityUtils.getUserId();
        List menus = this.menuService.selectMenuList(menu, userId);
        return this.success((Object)menus);
    }

    @RequiresPermissions(value={"system:menu:query"})
    @GetMapping(value={"/{menuId}"})
    public AjaxResult getInfo(@PathVariable Long menuId) {
        return this.success((Object)this.menuService.selectMenuById(menuId));
    }

    @GetMapping(value={"/treeselect"})
    public AjaxResult treeselect(SysMenu menu) {
        Long userId = SecurityUtils.getUserId();
        List menus = this.menuService.selectMenuList(menu, userId);
        return this.success((Object)this.menuService.buildMenuTreeSelect(menus));
    }

    @GetMapping(value={"/roleMenuTreeselect/{roleId}"})
    public AjaxResult roleMenuTreeselect(@PathVariable(value="roleId") Long roleId) {
        Long userId = SecurityUtils.getUserId();
        List menus = this.menuService.selectMenuList(userId);
        AjaxResult ajax = AjaxResult.success();
        ajax.put("checkedKeys", (Object)this.menuService.selectMenuListByRoleId(roleId));
        ajax.put("menus", (Object)this.menuService.buildMenuTreeSelect(menus));
        return ajax;
    }

    @RequiresPermissions(value={"system:menu:add"})
    @Log(title="菜单管理", businessType=BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody SysMenu menu) {
        if (!this.menuService.checkMenuNameUnique(menu)) {
            return this.error("新增菜单'" + menu.getMenuName() + "'失败，菜单名称已存在");
        }
        if ("0".equals(menu.getIsFrame()) && !StringUtils.ishttp((String)menu.getPath())) {
            return this.error("新增菜单'" + menu.getMenuName() + "'失败，地址必须以http(s)://开头");
        }
        menu.setCreateBy(SecurityUtils.getUsername());
        return this.toAjax(this.menuService.insertMenu(menu));
    }

    @RequiresPermissions(value={"system:menu:edit"})
    @Log(title="菜单管理", businessType=BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@Validated @RequestBody SysMenu menu) {
        if (!this.menuService.checkMenuNameUnique(menu)) {
            return this.error("修改菜单'" + menu.getMenuName() + "'失败，菜单名称已存在");
        }
        if ("0".equals(menu.getIsFrame()) && !StringUtils.ishttp((String)menu.getPath())) {
            return this.error("修改菜单'" + menu.getMenuName() + "'失败，地址必须以http(s)://开头");
        }
        if (menu.getMenuId().equals(menu.getParentId())) {
            return this.error("修改菜单'" + menu.getMenuName() + "'失败，上级菜单不能选择自己");
        }
        menu.setUpdateBy(SecurityUtils.getUsername());
        return this.toAjax(this.menuService.updateMenu(menu));
    }

    @RequiresPermissions(value={"system:menu:remove"})
    @Log(title="菜单管理", businessType=BusinessType.DELETE)
    @DeleteMapping(value={"/{menuId}"})
    public AjaxResult remove(@PathVariable(value="menuId") Long menuId) {
        if (this.menuService.hasChildByMenuId(menuId)) {
            return this.warn("存在子菜单,不允许删除");
        }
        if (this.menuService.checkMenuExistRole(menuId)) {
            return this.warn("菜单已分配,不允许删除");
        }
        return this.toAjax(this.menuService.deleteMenuById(menuId));
    }

    @GetMapping(value={"getRouters"})
    public AjaxResult getRouters() {
        Long userId = SecurityUtils.getUserId();
        List menus = this.menuService.selectMenuTreeByUserId(userId);
        return this.success((Object)this.menuService.buildMenus(menus));
    }
}

